#include <stdio.h>
#include <stdlib.h>
#include "qwsim.h"
#include <math.h>
#include <time.h>



void parser_aux(FILE *fp,double * a){
	int ch;
	double test;
	int k=1;
	
	printf("\n");
	ch = fgetc(fp);
	while( ch != EOF && ch != ' ' && ch != '\n'){
			printf("%c",ch);
			ch = fgetc(fp);		
	}

	printf("%c",ch);
	k = 0;
	while( ch != EOF && ch != '\n'){
		fscanf(fp,"%lf",&a[k]);
		printf("  a[%d] = %lf ",k, *(a+k));
		k++;
		ch = fgetc(fp);
	}

	printf("\n");
	while(ch == ' '){
		fscanf(fp,"%lf",&a[k]);
		printf("  a[%d] = %lf" ,k, *(a+k));

		ch = fgetc(fp);
	}
	ch = fgetc(fp);
	while( ch != EOF && ch != ' ' && ch != '\n'){
			printf("%c",ch);
			ch = fgetc(fp);		
	}
	printf("\n");

}

void parser(){

	FILE *fp;
	int points;
	double test, pp, *aux, normalizer = 0.0;
	int *i, *j, *c,l, moi, moj, ref1, ref2;
	complex *v;

	Edges = 2;

	fp = fopen("parse_file.txt","r");
	
	parser_aux(fp,&pp);
	N = (int )pp;
	printf(" M = %d \n", N);

	parser_aux(fp,&pp);
	steps = (int )pp;printf(" steps = %d \n", steps);
	steps = steps +1;

	parser_aux(fp,&pp);
	points = (int )pp;printf(" points = %d \n", points);

	aux = (double *)malloc(sizeof(double) * points);
	i = (int *)malloc(sizeof(int) * points);
	c = (int *)malloc(sizeof(int) * points);
	v = (complex *)malloc(sizeof(complex) * points);

	
	parser_aux(fp,aux); for(l=0; l < points; l++){ i[l] =(int ) aux[l]; printf("i[%d] = %d\n", l, i[l]);}
	parser_aux(fp,aux); for(l=0; l < points; l++){ c[l] =(int ) aux[l]; printf("c[%d] = %d\n", l, c[l]);}
	parser_aux(fp,aux); for(l=0; l < points; l++){ v[l].re = aux[l]; normalizer = normalizer + aux[l]*aux[l]; printf("v.re[%d] = %lf\n", l, v[l].re);}
	parser_aux(fp,aux); for(l=0; l < points; l++){ v[l].im = aux[l]; normalizer = normalizer + aux[l]*aux[l]; printf("v.im[%d] = %lf\n", l, v[l].im);}
	free(aux);

	parser_aux(fp,&pp);printf("index_brokenlink_imp = %lf \n", pp);
	index_brokenlink_imp =  pp;

	initialize_global_variables();

	int ad=0;
	double * aux_i, *aux_2;
	parser_aux(fp,&pp);printf("number of fixed broken links = %lf \n", pp);
	fixed_broken_link = pp;
	aux_i = (double *)malloc(sizeof(double) * fixed_broken_link);
	parser_aux(fp,aux_i);
	for(l=0; l < fixed_broken_link; l++)printf("fixed broken link = %lf\n",aux_i[l]);
	printf("test 1\n");
	for(l=0; l < fixed_broken_link; l++)permanent_broken_link1D((int ) aux_i[l] , ad);
	free(aux_i);

	
	circle1D();

	parser_aux(fp,&pp);
	coin1 = (int) pp;printf("ccoin = %lf \n", pp);

	parser_aux(fp,&pp);printf("varying coin at each step = %lf \n", pp);
	varying_coin_each_step = (int) pp;

	if(varying_coin_each_step == 1){


    for(l=0; l < Nodes; l++) pos_coin[l] = 5;


		range_fixed = (double **)malloc(sizeof(double * )*1);
		range_fixed[0] = (double *)malloc(sizeof(double ) * 6);
	
		parser_aux(fp,&pp);
		range_fixed[0][0] = pp;

		parser_aux(fp,&pp);
		range_fixed[0][1] = pp;

		parser_aux(fp,&pp);
		range_fixed[0][2] = pp;

		parser_aux(fp,&pp);
		range_fixed[0][3] = pp;

		parser_aux(fp,&pp);
		range_fixed[0][4] = pp;

		parser_aux(fp,&pp);
		range_fixed[0][5] = pp;

	}
	else{
		parser_aux(fp,&pp);
		parser_aux(fp,&pp);
		parser_aux(fp,&pp);
		parser_aux(fp,&pp);
		parser_aux(fp,&pp);
		parser_aux(fp,&pp);

	}

	parser_aux(fp,&pp);printf("index_coin_imp = %lf \n", pp);
	index_coin_imp =  pp;

	parser_aux(fp,&pp);printf("number of fixed coins = %lf \n", pp);
	fixed_coins =(int ) pp;
	

	range = (double **)malloc(sizeof(double * ) * Nodes);
	for(l=0; l < Nodes; l++) range[l] = (double *)malloc(sizeof(double ) * 6);

	aux_i = (double *)malloc(sizeof(double) * fixed_coins);
	parser_aux(fp,aux_i);

	aux_2 = (double *)malloc(sizeof(double) * fixed_coins);

	for(l=0; l < fixed_coins; l++) pos_coin[((int ) aux_i[l]) + N] = 4;

	parser_aux(fp,aux_2);
	for(l=0; l < fixed_coins; l++)range[((int ) aux_i[l])+ N][0] = aux_2[l];

	parser_aux(fp,aux_2);
	for(l=0; l < fixed_coins; l++)range[((int ) aux_i[l]) + N][1] = aux_2[l];

	parser_aux(fp,aux_2);
	for(l=0; l < fixed_coins; l++)range[((int ) aux_i[l]) + N][2] = aux_2[l];

	parser_aux(fp,aux_2);
	for(l=0; l < fixed_coins; l++)range[((int ) aux_i[l]) + N][3] = aux_2[l];

	parser_aux(fp,aux_2);
	for(l=0; l < fixed_coins; l++)range[((int ) aux_i[l]) + N][4] = aux_2[l];

	parser_aux(fp,aux_2);
	for(l=0; l < fixed_coins; l++)range[((int ) aux_i[l]) + N][5] = aux_2[l];


 
	normalizer = sqrt(normalizer);
	for(l=0; l < points; l++){
		printf("normalizer = %lf\n", normalizer);
		M(s1[biject1D(i[l])].direction,c[l],0).re = v[l].re/normalizer;
		//printf("s(%d, %d, %d) = %lf \n", i[l], j[l], c[l],M(s1[biject(i[l],j[l])].direction,c[l],0).re);	
		M(s1[biject1D(i[l])].direction,c[l],0).im = v[l].im/normalizer;
		printf("prob test = %lf\n", prob_test(s1));
	}
 

	parser_aux(fp,&pp); ref = (int )pp; printf("ref = %d \n", ref);
	if(ref == 1)reflect1D();


	parser_aux(fp,&pp);
	dim_absorb = (int) pp; printf("dim_absorb = %d \n", dim_absorb);

	if(dim_absorb != 0){
		aux = (double *)malloc(sizeof(double) * dim_absorb);
		initialize_absorb();
		parser_aux(fp,aux); for(l=0; l < dim_absorb; l++){ absorb[l][0] =(int ) aux[l];} //printf("i_0[%d] = %d\n", l, absorb[l][0]);}
		parser_aux(fp,aux); for(l=0; l < dim_absorb; l++){ absorb[l][1] =(int ) aux[l];} //printf("c_0[%d] = %d\n", l, absorb[l][1]);}
		free(aux);
	}
	else{
		parser_aux(fp,&pp); 
		parser_aux(fp,&pp);	
	}


	parser_aux(fp,&pp); gnu = (int ) pp;
    printf("gnu = %d \n", gnu);

	fclose(fp);



}

int main(void){
	int i,j, r[2];
	double p, xy;
	double xy_mean[2];

	c_matrix H, Pt, R, QRD, x_adj;
	c_matrix test, test_t, I;
	time_t t;
	t = time( NULL  );
	srand(t);
	t_counter = 1;

	parser();
	qw_on_plane(s1, s2);

	p = prob_test(s1);
	plots();
	if(gnu == 1)
		gnu_plots();

	//printf("\n %f \n",p);

	return 0;
}
