 function plots()

fs = 20;
fs2 = 20;
data = load('standard_deviation');
k = size(data);
h = figure
plot(data(:,1), data(:,2));
xlabel('time','fontsize',fs);
title('\sigma_x','fontsize',fs);
set(gca,'fontsize',fs2)
saveas(h,'standard_deviation.eps','psc2');


fs = 20;
fs2 = 20;
data = load('von_Neumann_entropy');
k = size(data);
h = figure
plot(data(:,1), data(:,2));
xlabel('time','fontsize',fs);
title('S(\rho_C)','fontsize',fs);
set(gca,'fontsize',fs2)
saveas(h,'von_Neumann_entropy.eps','psc2');

fs = 20;
fs2 = 20;
data = load('Shannon_entropy');
k = size(data);
h = figure
plot(data(:,1), data(:,2));
xlabel('time','fontsize',fs);
title('H(C)','fontsize',fs);
set(gca,'fontsize',fs2)
saveas(h,'Shannon_entropy.eps','psc2');


fs = 20;
fs2 = 20;
data = load('Probability_Distribution');
k = size(data);
h = figure
plot(data(:,1), data(:,2));
xlabel('time','fontsize',fs);
title('Probability Distribution','fontsize',fs);
set(gca,'fontsize',fs2)
saveas(h,'Probability_Distribution.eps','psc2');

fs = 20;
fs2 = 20;
data = load('Average_Probability_Distribution');
k = size(data);
h = figure
plot(data(:,1), data(:,2));
xlabel('time','fontsize',fs);
title('Average Probability Distribution','fontsize',fs);
set(gca,'fontsize',fs2)
saveas(h,'Average_Probability_Distribution.eps','psc2');


fs = 20;
fs2 = 20;
data = load('mean_x');
k = size(data);
h = figure
plot(data(:,1), data(:,2));
xlabel('time','fontsize',fs);
title('<x>','fontsize',fs);
set(gca,'fontsize',fs2)
saveas(h,'mean_x.eps','psc2');






